!classDefinition: #MarsRoverTest category: #MarsRover!
TestCase subclass: #MarsRoverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test01EmptyCommandsDoNotMoveTheMarsRover
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:''.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test02fCommandMovesTheMarsRoverForward
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:'f'.
	
	self assert: 0@1 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test03bCommandMovesTheMarsRoverBackwards
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:'b'.
	
	self assert: 0@-1 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test04lCommandTurnsTheMarsRoverNinetyDegreesLeft
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:'l'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #West equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test05rCommandTurnsTheMarsRoverNinetyDegreesRight
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:'r'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #East equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test06TheMarsRoverAcceptsMoreThanOneCommandSentAtTheSameTime
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	marsRover sendCommands:'ff'.
	
	self assert: 0@2 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test07MarsRoverPointingEastTurnsNinetyDegreesRightToPointSouth
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#East.
	
	marsRover sendCommands:'r'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #South equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test08MarsRoverPointingEastTurnsNinetyDegreesLeftToPointNorth

	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#East.
	
	marsRover sendCommands:'l'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test09MarsRoverPointingWestTurnsNinetyDegreesLeftToPointSouth

	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#West.
	
	marsRover sendCommands:'l'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #South equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test10MarsRoverPointingWestTurnsNinetyDegreesRightToPointNorth

	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#West.
	
	marsRover sendCommands:'r'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #North equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test11MarsRoverPointingSouthTurnsNinetyDegreesLeftToPointEast

	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#South.
	
	marsRover sendCommands:'l'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #East equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test12MarsRoverPointingSouthTurnsNinetyDegreesRightToPointWest

	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#South.
	
	marsRover sendCommands:'r'.
	
	self assert: 0@0 equals: marsRover position.
	self assert: #West equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:27'!
test13MarsRoverPointingEastMovesForwardTowardsTheEast
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#East.
	
	marsRover sendCommands:'f'.
	
	self assert: 1@0 equals: marsRover position.
	self assert: #East equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test14MarsRoverPointingEastMovesBackwardsTowardsTheWest
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#East.
	
	marsRover sendCommands:'b'.
	
	self assert: -1@0 equals: marsRover position.
	self assert: #East equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test15MarsRoverPointingWestMovesForwardTowardsTheWest
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#West.
	
	marsRover sendCommands:'f'.
	
	self assert: -1@0 equals: marsRover position.
	self assert: #West equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test16MarsRoverPointingWestMovesBackwardsTowardsTheEast
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#West.
	
	marsRover sendCommands:'b'.
	
	self assert: 1@0 equals: marsRover position.
	self assert: #West equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test17MarsRoverPointingSouthMovesForwardTowardsTheSouth
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#South.
	
	marsRover sendCommands:'f'.
	
	self assert: 0@-1 equals: marsRover position.
	self assert: #South equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test18MarsRoverPointingSouthMovesBackwardsTowardsTheNorth
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#South.
	
	marsRover sendCommands:'b'.
	
	self assert: 0@1 equals: marsRover position.
	self assert: #South equals: marsRover direction direction.! !

!MarsRoverTest methodsFor: 'testing' stamp: 'MEV 5/13/2019 12:43:26'!
test19ProcessingAnIncorrectCommandWillStopProcessingTheRestOfTheCommandsAndSendAnErrorSignal
	
	|marsRover|
	marsRover := MarsRover atCoordinates: 0@0 pointingInDirection:#North.
	
	self should: [ marsRover sendCommands:'rrffxb'. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = MarsRover incorrectCommandErrorSignal.
			self assert: 0@-2 equals: marsRover position.
			self assert: #South equals: marsRover direction direction.].
		
		! !


!classDefinition: #CardinalDirection category: #MarsRover!
Object subclass: #CardinalDirection
	instanceVariableNames: 'direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!CardinalDirection methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:28:53'!
onePointBackwardsFrom: aCoordinate

	self subclassResponsibility .! !

!CardinalDirection methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:26:24'!
onePointForwardFrom: aCoordinate

	self subclassResponsibility .! !

!CardinalDirection methodsFor: 'movement' stamp: 'MEV 5/11/2019 18:54:27'!
rotateNinetyDegreesLeft
	
		self subclassResponsibility.! !

!CardinalDirection methodsFor: 'movement' stamp: 'MEV 5/11/2019 18:54:32'!
rotateNinetyDegreesRight
	
		self subclassResponsibility.! !


!CardinalDirection methodsFor: 'accessing' stamp: 'MEV 5/13/2019 12:43:26'!
direction

	^direction .! !


!CardinalDirection methodsFor: 'initialization' stamp: 'MEV 5/13/2019 12:44:10'!
initialize

	^CardinalDirection pointing:#North.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'CardinalDirection class' category: #MarsRover!
CardinalDirection class
	instanceVariableNames: ''!

!CardinalDirection class methodsFor: 'class initialization' stamp: 'MEV 5/11/2019 19:33:59'!
cardinalDirectionDoesNotExistErrorSignal

	^'Incorrect cardinal direction'.! !

!CardinalDirection class methodsFor: 'class initialization' stamp: 'MEV 5/11/2019 19:33:17'!
pointing: aCardinalDirection

	(aCardinalDirection = #North)ifTrue:[^North new].
	(aCardinalDirection = #East)ifTrue:[^East new].
	(aCardinalDirection = #West)ifTrue:[^West new].
	(aCardinalDirection = #South)ifTrue:[^South new].
	self error: self cardinalDirectionDoesNotExistErrorSignal.! !


!classDefinition: #East category: #MarsRover!
CardinalDirection subclass: #East
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!East methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:29:26'!
onePointBackwardsFrom: aCoordinate

	^aCoordinate + (-1@0)! !

!East methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:27:01'!
onePointForwardFrom: aCoordinate

	^aCoordinate +  (1@0)! !

!East methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesLeft
	
		^CardinalDirection pointing: #North! !

!East methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:36'!
rotateNinetyDegreesRight
	
		^CardinalDirection pointing: #South! !


!East methodsFor: 'initialization' stamp: 'MEV 5/13/2019 12:42:28'!
initialize

	direction := #East.! !


!classDefinition: #North category: #MarsRover!
CardinalDirection subclass: #North
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!North methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:30:34'!
onePointBackwardsFrom: aCoordinate

	^aCoordinate + (0@-1)! !

!North methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:26:49'!
onePointForwardFrom: aCoordinate

	^aCoordinate +  (0@1)! !

!North methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesLeft
	
		^CardinalDirection pointing: #West! !

!North methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesRight
	
		^CardinalDirection pointing: #East! !


!North methodsFor: 'initialization' stamp: 'MEV 5/13/2019 12:42:28'!
initialize

	direction := #North.! !


!classDefinition: #South category: #MarsRover!
CardinalDirection subclass: #South
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!South methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:30:42'!
onePointBackwardsFrom: aCoordinate

	^aCoordinate + (0@1)! !

!South methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:27:08'!
onePointForwardFrom: aCoordinate

	^aCoordinate +  (0@-1)! !

!South methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesLeft
	
		^CardinalDirection pointing: #East! !

!South methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesRight

		^CardinalDirection pointing: #West! !


!South methodsFor: 'initialization' stamp: 'MEV 5/13/2019 12:42:28'!
initialize

	direction := #South.! !


!classDefinition: #West category: #MarsRover!
CardinalDirection subclass: #West
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!West methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:30:50'!
onePointBackwardsFrom: aCoordinate

	^aCoordinate + (1@0)! !

!West methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:27:15'!
onePointForwardFrom: aCoordinate

	^aCoordinate +  (-1@0)! !

!West methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesLeft
	
		^CardinalDirection pointing: #South! !

!West methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:21:37'!
rotateNinetyDegreesRight
	
		^CardinalDirection pointing: #North! !


!West methodsFor: 'initialization' stamp: 'MEV 5/13/2019 12:42:28'!
initialize

	direction := #West.! !


!classDefinition: #MarsRover category: #MarsRover!
Object subclass: #MarsRover
	instanceVariableNames: 'coordinates cardinalDirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarsRover'!

!MarsRover methodsFor: 'initialize' stamp: 'MEV 5/12/2019 16:42:12'!
initializeWithCoordinate: aCoordinate andCardinalDirection: aCardinalDirection

		coordinates := aCoordinate.
		cardinalDirection := CardinalDirection pointing:aCardinalDirection .
	! !


!MarsRover methodsFor: 'auxiliary' stamp: 'MEV 5/12/2019 16:38:03'!
processCommand: aCommand

	(aCommand = $f)ifTrue:[self advanceInDirection: cardinalDirection.].
	(aCommand = $b)ifTrue:[self reverseInDirection: cardinalDirection.].
	(aCommand = $l)ifTrue:[cardinalDirection := self rotateNinetyDegreesLeft.].
	(aCommand = $r)ifTrue:[cardinalDirection := self rotateNinetyDegreesRight.].
	(#($f $b $l $r) includes: aCommand) ifFalse:[self error: MarsRover incorrectCommandErrorSignal .]! !


!MarsRover methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:32:24'!
advanceInDirection: aCardinalDirection

		coordinates := aCardinalDirection onePointForwardFrom: coordinates.
! !

!MarsRover methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:32:30'!
reverseInDirection: aCardinalDirection 
	
	coordinates := aCardinalDirection onePointBackwardsFrom: coordinates.
	! !

!MarsRover methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:32:34'!
rotateNinetyDegreesLeft
	
		^cardinalDirection rotateNinetyDegreesLeft .
	
! !

!MarsRover methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:32:38'!
rotateNinetyDegreesRight
	
		^cardinalDirection rotateNinetyDegreesRight .
	
! !

!MarsRover methodsFor: 'movement' stamp: 'MEV 5/12/2019 16:37:42'!
sendCommands: aStringOfCommands
	
	aStringOfCommands do:[ :aCommand | self processCommand: aCommand.]
! !


!MarsRover methodsFor: 'accessing' stamp: 'MEV 5/13/2019 12:43:25'!
direction
	
	^cardinalDirection.! !

!MarsRover methodsFor: 'accessing' stamp: 'MEV 5/11/2019 18:44:59'!
position
	
	^coordinates! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'MarsRover class' category: #MarsRover!
MarsRover class
	instanceVariableNames: ''!

!MarsRover class methodsFor: 'class initialization' stamp: 'MEV 5/11/2019 18:15:11'!
atCoordinates: aCoordinate pointingInDirection: aCardinalPoint 
	
	
	^self new initializeWithCoordinate: aCoordinate andCardinalDirection: aCardinalPoint .! !


!MarsRover class methodsFor: 'error descriptions' stamp: 'MEV 5/9/2019 19:29:30'!
incorrectCommandErrorSignal

	^'Incorrect command'! !
