!classDefinition: #TermiLapilliTest category: #TermiLapilli!
TestCase subclass: #TermiLapilliTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:27:28'!
test01FirstPlayerPlacesAnXOnTheFirstTurn

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	
	self assert: (board at: 1@1) equals: 'X'.
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:27:55'!
test02FirstPlayerCanNotPlaceAnOOnTheFirstTurn

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	
	self assert: ((board at:1@1) = 'O') equals:false.
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:30:02'!
test03SecondPlayerPlacesAnOOnTheSecondTurn

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	
	self assert: (board at: 1@1) equals: 'X'.
	self assert: (board at: 1@2) equals: 'O'.
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:31:03'!
test04CanNotPlaceATokenOnAnOccupiedPosition

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	
	
	self should: [ board playAt: 1@1. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantPlayInOccupiedPositionErrorSignal.
			self assert: (board at:1@1) equals:'X'.].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:33:21'!
test05ThereAreOnlyTwoPlayersAndPlayAlternatelyXAndOStartingWithX

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	
	self assert: (board at: 1@1) equals: 'X'.
	self assert: (board at: 1@2) equals: 'O'.
	self assert: (board at: 1@3) equals: 'X'.
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:33:46'!
test06CanNotPlaceATokenOutsideTheBounderiesOfTheBoard

	|board|
	
	board := TermiLapilli new.
	
	self should: [ board playAt: 1@4. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli incorrectPositionErrorSignal.].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:34:12'!
test07ThereCanOnlyBeThreeXAndThreeOOnTheBoard

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	
	self should: [ board playAt: 3@1. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantPlaceAnotherTokenErrorSignal.
			self assert: (board at:3@1) equals: #Empty].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:34:50'!
test08ThreeXOnTheFirstRowOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 2@1.
	board playAt: 1@2.
	board playAt: 2@2.
	board playAt: 1@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:35:16'!
test09ThreeOOnTheFirstRowOfTheBoardGivesTheOPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 3@1.
	board playAt: 1@1.
	board playAt: 2@1.
	board playAt: 1@2.
	board playAt: 3@2.
	board playAt: 1@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'O'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:35:41'!
test10ThreeXOnTheSecondRowOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 2@1.
	board playAt: 1@1.
	board playAt: 2@2.
	board playAt: 1@2.
	board playAt: 2@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:35:59'!
test11ThreeXOnTheThirdRowOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 3@1.
	board playAt: 1@1.
	board playAt: 3@2.
	board playAt: 1@2.
	board playAt: 3@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:36:51'!
test12ThreeXOnTheFirstColumnOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 2@1.
	board playAt: 1@3.
	board playAt: 3@1.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:37:11'!
test13ThreeXOnTheSecondColumnOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@2.
	board playAt: 1@1.
	board playAt: 2@2.
	board playAt: 1@3.
	board playAt: 3@2.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:37:23'!
test14ThreeXOnTheThirdColumnOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@3.
	board playAt: 1@1.
	board playAt: 2@3.
	board playAt: 1@2.
	board playAt: 3@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:38:24'!
test15ThreeXOnTheDiagonalStartingOnTheTopLeftCornerOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 1@2.
	board playAt: 3@3.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:38:37'!
test16ThreeXOnTheDiagonalStartingOnTheTopRightCornerOfTheBoardGivesTheXPlayerTheWin

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 1@2.
	board playAt: 3@1.
	
	self assert: (board isFinished) equals:true.
	self assert: (board winner) equals: 'X'
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:39:21'!
test17CanNotPlaceATokenWhenTheGameIsFinished

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 1@2.
	board playAt: 3@1.
	
	self should: [ board playAt: 2@3. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantPlayWhenGameIsFinishedErrorSignal .
			self assert: (board isFinished) equals:true.
			self assert: (board winner) equals: 'X'.].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:41:13'!
test18CanNotMoveATokenWhileThereAreTokensToBePlaced

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	
	self should: [ board move:1@1 to:1@2. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantMoveWhileThereAreTokensToBePlayedErrorSignal.
			self assert: (board at:1@1) equals:'X'.].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:41:59'!
test19CanNotMoveATokenWhichIsNotMine

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	
	self should: [ board move:2@1 to: 3@1. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantMoveAnIncorrectTokenErrorSignal.
			self assert: (board at:2@1) equals:'O'].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:42:23'!
test20CanNotMoveToAnOccupiedPositionOfTheBoard

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	
	self should: [ board move:1@1 to: 1@2. ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantPlayInOccupiedPositionErrorSignal.
			self assert: (board at:1@1) equals:'X'.
			self assert: (board at:1@2) equals:'O'.].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:44:59'!
test21CanMoveAnXTokenFromOnePositionOnTheBoardToAnother

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	board move: 2@2 to: 3@2.
	
	self deny:(board isOccupied: 2@2).
	self assert: (board at:3@2) equals:'X'. 
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:45:16'!
test22CanMoveAnOTokenFromOnePositionOnTheBoardToAnother

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	board move: 2@2 to: 3@2.
	board move: 2@1 to: 3@1. 
	
	self deny:(board isOccupied: 2@1).
	self assert: (board at:3@1) equals:'O'. 
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:46:08'!
test23CanOnlyMoveATokenToAPositionSurroundingTheSourcePosition

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 3@1.
	board playAt: 3@2.
	board playAt: 3@3.
	
	self should: [board move: 1@1 to: 2@3.]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantMoveToAPositionNotSurroundingTheSourcePositionErrorSignal.
			self assert: (board at:1@1) equals:'X'.
			self deny: (board isOccupied: 2@3).].
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:47:02'!
test24CanNotMoveATokenWhenTheGameIsFinished

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	board playAt: 1@3.
	board playAt: 3@2.
	board move: 2@2 to: 1@2. 
	
	self should: [board move: 2@1 to: 3@1.]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli cantPlayWhenGameIsFinishedErrorSignal .
			self assert: (board at:2@1) equals:'O'.
			self deny: (board isOccupied: 3@1).].
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:47:27'!
test25CanNotMoveATokenToAnIncorrectPosition

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	
	self should: [board move: 2@2 to: 4@2.]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli incorrectPositionErrorSignal .
			self assert: (board at:2@2) equals:'X'.].
	
	
	
	! !

!TermiLapilliTest methodsFor: 'testing' stamp: 'MEV 5/26/2019 18:47:43'!
test26CanNotMoveATokenFromAnIncorrectPosition

	|board|
	
	board := TermiLapilli new.
	board playAt: 1@1.
	board playAt: 1@2.
	board playAt: 1@3.
	board playAt: 2@1.
	board playAt: 2@2.
	board playAt: 2@3.
	
	self should: [board move: 4@2 to: 3@2.]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = TermiLapilli incorrectPositionErrorSignal .
			self assert: (board at:2@2) equals:'X'.].
	
	
	
	! !


!classDefinition: #TermiLapilli category: #TermiLapilli!
Object subclass: #TermiLapilli
	instanceVariableNames: 'phase board nextPlayer amountOfTokens winner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!TermiLapilli methodsFor: 'play' stamp: 'MEV 5/26/2019 20:12:46'!
acceptPlayAt: aPosition

		self at: aPosition put: self nextPlayer .
		self changePlayer.
		(self isFinished )ifTrue:[self changeToFinishedPhase.].! !

!TermiLapilli methodsFor: 'play' stamp: 'MEV 5/26/2019 21:02:49'!
at: aPosition put: aToken

	board at:aPosition put: aToken.
		
		

	! !

!TermiLapilli methodsFor: 'play' stamp: 'MEV 5/21/2019 20:55:51'!
increaseAmountOfTokens

	amountOfTokens := amountOfTokens + 1.
		
		

	! !

!TermiLapilli methodsFor: 'play' stamp: 'MEV 5/26/2019 16:08:19'!
move: aPosition to: anotherPosition

	phase move: aPosition to: anotherPosition atBoard: self. 
	! !

!TermiLapilli methodsFor: 'play' stamp: 'MEV 5/26/2019 16:03:50'!
playAt: aPosition

		phase playAt: aPosition atBoard:self.
		
		
		

	! !


!TermiLapilli methodsFor: 'initialization' stamp: 'MEV 5/27/2019 13:16:45'!
initialize

		|arrayOfArrays|
		arrayOfArrays := Array with: (Array with: #Empty with: #Empty with: #Empty)
						  with: (Array with: #Empty with: #Empty with: #Empty)
						  with: (Array with: #Empty with: #Empty with: #Empty).
		board := Array2D fromArrayOfArrays: arrayOfArrays .	.
		
		nextPlayer := 'X'.
		amountOfTokens := 0.
		winner :='No winners yet'.
		phase := TermiLapilliPhase new.! !


!TermiLapilli methodsFor: 'phase change' stamp: 'MEV 5/26/2019 16:06:26'!
changeToFinishedPhase

	phase := FinishedGamePhase basicNew.! !

!TermiLapilli methodsFor: 'phase change' stamp: 'MEV 5/26/2019 16:06:15'!
changeToMovingPhase

	phase := MovingTokenPhase basicNew.! !


!TermiLapilli methodsFor: 'player change' stamp: 'MEV 5/26/2019 21:03:19'!
changePlayer

		(nextPlayer = 'X')ifTrue:[nextPlayer := 'O']ifFalse:[nextPlayer := 'X'.].
		! !


!TermiLapilli methodsFor: 'accessing' stamp: 'MEV 5/26/2019 16:00:53'!
amountOfTokens

	^amountOfTokens .! !

!TermiLapilli methodsFor: 'accessing' stamp: 'MEV 5/26/2019 21:03:14'!
at: aPosition

	^board at:aPosition .! !

!TermiLapilli methodsFor: 'accessing' stamp: 'MEV 5/26/2019 16:03:34'!
nextPlayer 

	^nextPlayer .! !

!TermiLapilli methodsFor: 'accessing' stamp: 'MEV 5/21/2019 19:02:10'!
winner

	^winner.! !


!TermiLapilli methodsFor: 'position test' stamp: 'MEV 5/26/2019 22:22:21'!
checkPosition: aPosition 

	
	self validPosition: aPosition.
	(self isOccupied:aPosition)ifTrue:[self error: TermiLapilli cantPlayInOccupiedPositionErrorSignal .].
! !

!TermiLapilli methodsFor: 'position test' stamp: 'MEV 5/26/2019 22:24:53'!
checkPositionsWhenMovingFrom: aPosition to: anotherPosition

	
	self checkPosition: anotherPosition .
	self validPosition: aPosition.
	
	((self at: aPosition) = self nextPlayer)ifFalse:[self error: TermiLapilli cantMoveAnIncorrectTokenErrorSignal .]. 
	(self position:anotherPosition isSurrounding:aPosition)ifFalse:[
			self error: TermiLapilli cantMoveToAPositionNotSurroundingTheSourcePositionErrorSignal .].! !

!TermiLapilli methodsFor: 'position test' stamp: 'MEV 5/21/2019 18:58:32'!
isOccupied: aPosition

		^(self at:aPosition) ~= #Empty.! !

!TermiLapilli methodsFor: 'position test' stamp: 'MEV 5/21/2019 21:46:02'!
position:aPosition isSurrounding:anotherPosition

	^((anotherPosition) eightNeighbors)includes: aPosition.! !

!TermiLapilli methodsFor: 'position test' stamp: 'MEV 5/26/2019 16:41:20'!
validPosition: aPosition

	|validPosition|
	
	validPosition := ((aPosition x) between: 1 and: 3) and: ((aPosition y) between: 1 and: 3).
	
	(validPosition )ifFalse:[self error: TermiLapilli incorrectPositionErrorSignal] .
	
	^true.! !


!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/23/2019 18:38:08'!
isFinished

	^(((self winnerInAnyRow) | (self winnerInAnyColumn)) | (self winnerInAnyDiagonal)).
	! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/23/2019 18:37:52'!
winnerInAnyColumn

	^(((self winnerInColumn:1) | (self winnerInColumn:2)) | (self winnerInColumn:3)).
	! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/23/2019 18:39:09'!
winnerInAnyDiagonal

	^((self winnerInDiagonal)|(self winnerInInversedDiagonal)).! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/23/2019 18:38:32'!
winnerInAnyRow

	^(((self winnerInRow:1) | (self winnerInRow:2)) | (self winnerInRow:3)).
	! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/21/2019 20:42:30'!
winnerInColumn: aColumnNumber

	^self sameTokenIn: (1@aColumnNumber ) and: (2@aColumnNumber ) and:(3@aColumnNumber ). ! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/21/2019 20:39:03'!
winnerInDiagonal

	^self sameTokenIn: (1@1 ) and: (2@2 ) and:(3@3 ). ! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/21/2019 20:39:13'!
winnerInInversedDiagonal

	^self sameTokenIn: (1@3 ) and: (2@2 ) and:(3@1 ). ! !

!TermiLapilli methodsFor: 'winner search' stamp: 'MEV 5/21/2019 20:39:41'!
winnerInRow: aRowNumber

	^self sameTokenIn: (aRowNumber @1 ) and: (aRowNumber @2 ) and:(aRowNumber @3 ). ! !


!TermiLapilli methodsFor: 'auxiliary' stamp: 'MEV 5/26/2019 16:17:15'!
sameTokenIn: firstPosition and: secondPosition and: thirdPosition

	|firstToken secondToken thirdToken|
	
	firstToken := (self at:firstPosition ).
	secondToken := (self at:secondPosition ).
	thirdToken := (self at:thirdPosition).
	
	((firstToken ~=#Empty) & (firstToken = secondToken ) & (secondToken = thirdToken ))ifTrue: [winner := firstToken .^true.].
	
	^false.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'TermiLapilli class' category: #TermiLapilli!
TermiLapilli class
	instanceVariableNames: ''!

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/20/2019 19:09:45'!
cantMoveAnIncorrectTokenErrorSignal

	^'Can not move an incorrect token'! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/23/2019 19:21:38'!
cantMoveFromAnIncorrectPositionErrorSignal

	^'Can not move from an incorrect position'.! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/21/2019 21:36:12'!
cantMoveToAPositionNotSurroundingTheSourcePositionErrorSignal

	^'Can not move to a position that is not surrounding the source position'! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/20/2019 18:53:43'!
cantMoveWhileThereAreTokensToBePlayedErrorSignal

	^'Can not move while there are tokens to be played'! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/20/2019 18:54:03'!
cantPlaceAnotherTokenErrorSignal

	^'Can not play another token'! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/20/2019 18:03:59'!
cantPlayInOccupiedPositionErrorSignal

	^'Can not play in an occupied position'! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/21/2019 20:45:21'!
cantPlayWhenGameIsFinishedErrorSignal

	^'Can not play when game is already finished'.! !

!TermiLapilli class methodsFor: 'error' stamp: 'MEV 5/26/2019 16:32:20'!
incorrectPositionErrorSignal

	^'Can not play in an incorrect position'! !


!classDefinition: #TermiLapilliPhase category: #TermiLapilli!
Object subclass: #TermiLapilliPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!TermiLapilliPhase methodsFor: 'initialize' stamp: 'MEV 5/26/2019 16:16:57'!
initialize

	^PlacingTokenPhase basicNew.! !


!TermiLapilliPhase methodsFor: 'play' stamp: 'MEV 5/27/2019 13:14:03'!
move: aPosition to: anotherPosition atBoard: aTermiLapilliBoard. 

	self subclassResponsibility .! !

!TermiLapilliPhase methodsFor: 'play' stamp: 'MEV 5/27/2019 13:13:50'!
playAt:aPosition atBoard:aTermiLapilliBoard.

	self subclassResponsibility .! !


!classDefinition: #FinishedGamePhase category: #TermiLapilli!
TermiLapilliPhase subclass: #FinishedGamePhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!FinishedGamePhase methodsFor: 'play' stamp: 'MEV 5/26/2019 16:08:45'!
move: aPosition to: anotherPosition atBoard: aTermiLapilliBoard. 

	self error: TermiLapilli  cantPlayWhenGameIsFinishedErrorSignal .! !

!FinishedGamePhase methodsFor: 'play' stamp: 'MEV 5/26/2019 16:07:34'!
playAt:aPosition atBoard:aTermiLapilliBoard.

		self error: TermiLapilli  cantPlayWhenGameIsFinishedErrorSignal .
		
		
		
		
		! !


!classDefinition: #MovingTokenPhase category: #TermiLapilli!
TermiLapilliPhase subclass: #MovingTokenPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!MovingTokenPhase methodsFor: 'play' stamp: 'MEV 5/26/2019 22:24:54'!
move: aPosition to: anotherPosition atBoard: aTermiLapilliBoard. 

	aTermiLapilliBoard checkPositionsWhenMovingFrom: aPosition to: anotherPosition .
		
	aTermiLapilliBoard at:aPosition put:#Empty.
	aTermiLapilliBoard acceptPlayAt: anotherPosition .! !

!MovingTokenPhase methodsFor: 'play' stamp: 'MEV 5/26/2019 16:04:11'!
playAt:aPosition atBoard:aTermiLapilliBoard.

		self error: TermiLapilli cantPlaceAnotherTokenErrorSignal.
		
		! !


!classDefinition: #PlacingTokenPhase category: #TermiLapilli!
TermiLapilliPhase subclass: #PlacingTokenPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TermiLapilli'!

!PlacingTokenPhase methodsFor: 'play' stamp: 'MEV 5/26/2019 16:08:34'!
move: aPosition to: anotherPosition atBoard: aTermiLapilliBoard. 

	self error:TermiLapilli cantMoveWhileThereAreTokensToBePlayedErrorSignal.! !

!PlacingTokenPhase methodsFor: 'play' stamp: 'MEV 5/26/2019 22:23:04'!
playAt:aPosition atBoard: aTermiLapilliBoard.

		aTermiLapilliBoard checkPosition: aPosition .
		
		aTermiLapilliBoard increaseAmountOfTokens.
		aTermiLapilliBoard acceptPlayAt: aPosition.
		(aTermiLapilliBoard amountOfTokens = 6)ifTrue:[aTermiLapilliBoard changeToMovingPhase.] .
		
		
		
		
		! !
