!classDefinition: #RestGUI category: #'TusLibros.com-GUI'!
Panel subclass: #RestGUI
	instanceVariableNames: 'userTextBox passwordTextBox catalogListBox productQuantity cartContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros.com-GUI'!

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:42:08'!
build1stCatalogRow
	| firstRowLayout addToCart|
	
	addToCart := PluggableButtonMorph model: self model stateGetter: nil  action: #addToCart label: 'Add to Cart'.
	
	catalogListBox := PluggableListMorph model: self model listGetter: #productList indexGetter: #productListIndex indexSetter:#productListIndex: .
	catalogListBox borderWidth: 1.
	
	productQuantity := TextModelMorph textProvider: self model textGetter: #productQuantity textSetter: #productQuantity:. 
	productQuantity textMorph setProperty: #keyStroke: toValue: [ :key | productQuantity textMorph acceptContents ] .
	productQuantity  borderWidth: 1; borderColor: Color skyBlue.
		
	firstRowLayout := LayoutMorph newRow.
	firstRowLayout separation: 25;
	padding: #left;
	addMorph: (StringMorph contents:'Book Catalog: ');
	addMorph: catalogListBox ;
	addMorph: (StringMorph contents:'Amount: ');
	addMorph: productQuantity ;
	addMorph: addToCart .
	
	^firstRowLayout.! !

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 15:05:49'!
build2ndCatalogRow
	|firstRowLayout checkOut|
		
	cartContents := PluggableListMorph model: self model listGetter: #cartContents indexGetter: #cartContentsIndex indexSetter:#cartContentsIndex: .
	cartContents borderWidth: 1.
	
	checkOut := PluggableButtonMorph model: self model stateGetter: nil  action: #checkOutCart label: 'Check Out Cart'.
	
	firstRowLayout := LayoutMorph newRow.
	firstRowLayout separation: 25;
	padding: #left;
	addMorph: (StringMorph contents:'Cart contents: ');
	addMorph: cartContents;
	addMorph: checkOut.

	
	^firstRowLayout.! !

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 20:44:46'!
buildCatalogWindow
		
	self layoutMorph beColumn;
	separation: 15;
	padding: #left;
	addMorph: self build1stCatalogRow;
	addMorph: self build2ndCatalogRow.! !

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:35:26'!
catalogExtent

	^ 900@800
! !

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:40:35'!
openCatalogWith: aTitle andModel: aModel

	self titleMorph showButtonsNamed: #( close collapse ).
	self setLabel: aTitle.
	self model: aModel.
	self morphExtent: (self catalogExtent).
	self buildCatalogWindow.
	self openInWorld.
	self yourself.
	
	self model when: #addedMoreBooks send: #refreshCartContentsList to: self.! !

!RestGUI methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 15:45:12'!
refreshCartContentsList

	cartContents updateList.
	
	cartContents setSelectionIndex: 0.! !


!RestGUI methodsFor: 'log in window' stamp: 'MEV 7/10/2019 20:39:08'!
buildLogInRow
	| createCart firstRowLayout |
	
	createCart := PluggableButtonMorph model: self model stateGetter: nil  action: #createCart label: 'Create Cart'.
	
	userTextBox := TextModelMorph textProvider: self model textGetter: #client textSetter: #client:. 
	userTextBox textMorph setProperty: #keyStroke: toValue: [ :key | userTextBox textMorph acceptContents ] .
	userTextBox  borderWidth: 1; borderColor: Color skyBlue.
	
	passwordTextBox := TextModelMorph textProvider: self model textGetter: #password textSetter: #password:. 
	passwordTextBox textMorph setProperty: #keyStroke: toValue: [ :key | userTextBox textMorph acceptContents ] .
	passwordTextBox  borderWidth: 1; borderColor: Color skyBlue.
		
	firstRowLayout := LayoutMorph newRow.
	firstRowLayout separation: 25;
	padding: #left;
	addMorph: (StringMorph contents:'Client ID:');
	addMorph: userTextBox;
	addMorph: (StringMorph contents:'Password:');
	addMorph: passwordTextBox;
 	addMorph: createCart.
	
	^firstRowLayout.! !

!RestGUI methodsFor: 'log in window' stamp: 'MEV 7/10/2019 20:39:08'!
buildLogInWindow
		
	self layoutMorph beColumn;
	separation: 15;
	padding: #left;
	addMorph: self buildLogInRow.
! !

!RestGUI methodsFor: 'log in window' stamp: 'MEV 7/10/2019 20:40:23'!
initializeWith: aTitle

	self titleMorph showButtonsNamed: #( close collapse ).
	self setLabel: aTitle.
	self model: (RestGUIModel new).
	self morphExtent: (self logInExtent).
	self buildLogInWindow.
	self openInWorld.
	self yourself.! !

!RestGUI methodsFor: 'log in window' stamp: 'MEV 7/10/2019 20:40:09'!
logInExtent

	^ 800@300
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'RestGUI class' category: #'TusLibros.com-GUI'!
RestGUI class
	instanceVariableNames: ''!

!RestGUI class methodsFor: 'class initialization' stamp: 'MEV 7/10/2019 18:59:43'!
open
	
	^self new initializeWith: 'TusLibros'.! !

!RestGUI class methodsFor: 'class initialization' stamp: 'MEV 7/11/2019 15:50:59'!
openCatalogForClient: aClient andModel:aModel.
	
	^self new openCatalogWith: ('Cart for client: ',(aClient asString)) andModel: aModel.! !


!classDefinition: #RestGUIModel category: #'TusLibros.com-GUI'!
Object subclass: #RestGUIModel
	instanceVariableNames: 'webClient api client password cartID logInBehavior productList productListIndex productQuantity cartContentsIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros.com-GUI'!

!RestGUIModel methodsFor: 'initialization' stamp: 'MEV 7/11/2019 15:54:18'!
initialize

	api := RestAPI withMP:(StoreTestObjects new).
	productQuantity := '0'.
	productList := Array new.
	productListIndex := 0.
	cartContentsIndex := 0.
	logInBehavior := [ :clientId :clientPassword | ].
	client := ''.
	password := ''.! !


!RestGUIModel methodsFor: 'purchases transcript' stamp: 'MEV 7/11/2019 15:37:46'!
showPurchasesTranscript

	|transactionIDsOfClient sales|
	
	sales := OrderedCollection new.
	transactionIDsOfClient  := api transactionsOfClient: (self client).
	transactionIDsOfClient do:[:aTransactionID | sales add:(api transactionOfID: aTransactionID )].
	
	TranscriptWindow openTranscript.
	Transcript clear.
	Transcript show:'Purchases History'.
	Transcript newLine .
	
	sales do:[:aSale | self showSaleInTranscript: aSale].
		! !

!RestGUIModel methodsFor: 'purchases transcript' stamp: 'MEV 7/11/2019 15:35:25'!
showSaleInTranscript: aSale

	|transactions|
	
	transactions := aSale transactions .
	
	transactions do:[:aTransaction | Transcript show: ((aTransaction key,': '),(aTransaction value asString)) . Transcript newLine ].
	
	
		! !


!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 15:44:57'!
addToCart

	api addToCart: cartID bookISBN: (productList at:productListIndex) bookQuantity: (productQuantity asNumber).
	self triggerEvent: #addedMoreBooks with: self.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:32:20'!
cartContents

	|contents cartContents|
	
	cartContents := OrderedCollection new.
	
	contents := (api shoppingCartOfID: cartID) cartContents.
	
	contents do:[:aProductAndQuantity | cartContents add:((aProductAndQuantity key,': '),(aProductAndQuantity value asString))].
	
	^cartContents
	
	! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:23:47'!
cartContentsIndex

	^cartContentsIndex! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:24:11'!
cartContentsIndex: anIndex

	cartContentsIndex := anIndex.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 21:59:20'!
catalog

	^api catalog.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 15:16:50'!
checkOutCart

	|mp|
	
	mp := api merchantProcessor .
	
	api checkOutCart: cartID ccn: (mp notExpiredCreditCard ccn) cced:(mp notExpiredCreditCard cced)  cco: (mp notExpiredCreditCard cco).
	
	self showPurchasesTranscript.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 22:01:02'!
indexOfProduct: aProduct

	^(self productList) indexOf: aProduct ifAbsent: [0].! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 22:04:24'!
productList

	productList :=(self catalog keys).
	
	^productList.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 22:06:21'!
productListIndex

	^productListIndex.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/10/2019 22:06:33'!
productListIndex: anIndex

	productListIndex := anIndex.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:04:54'!
productQuantity

	^productQuantity.! !

!RestGUIModel methodsFor: 'catalog window' stamp: 'MEV 7/11/2019 14:14:09'!
productQuantity: aQuantity

	productQuantity := aQuantity .
	^true.! !


!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/10/2019 19:34:12'!
client
	
	^client.! !

!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/10/2019 19:34:36'!
client: aClient

	client := aClient .
	^true.! !

!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/11/2019 15:49:22'!
createCart

	api createCartWithId: client andPassword: password andValidateUsing: self.
	cartID := (api nextID) - 1.
	RestGUI openCatalogForClient: client andModel:self.! !

!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/10/2019 19:51:15'!
logInWithId: clientId andPassword: clientPassword

	^logInBehavior value: clientId value: clientPassword ! !

!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/10/2019 19:34:47'!
password
	
	^password.! !

!RestGUIModel methodsFor: 'log in window' stamp: 'MEV 7/10/2019 19:35:00'!
password: aPassword

	password := aPassword .
	^true.! !
