!classDefinition: #LunarRoverTest category: #ToTheMoonRemake!
TestCase subclass: #LunarRoverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test01LunarRoverDigsHardAndCompactSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Hard andPorosity:#Compact.
	lunarRover:=LunarRover digOn: soilType.
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:#ClockWise.
	self assert:(lunarRover speedInRPM)equals:150.
	self assert:(lunarRover timeRemainingOfWork)equals:10.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:06'!
test02LunarRoverDigsSoftAndPorousSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Soft andPorosity:#Porous.
	lunarRover:=LunarRover digOn:soilType .
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:#CounterClockWise.
	self assert:(lunarRover speedInRPM)equals:100.
	self assert:(lunarRover timeRemainingOfWork )equals:5.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test03LunarRoverDigsIntermediateSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Intermediate andPorosity:#Intermediate.
	lunarRover:=LunarRover digOn: soilType .
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:#ClockWise.
	self assert:(lunarRover speedInRPM)equals:150.
	self assert:(lunarRover timeRemainingOfWork)equals:5.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test04LunarRoverWorksAsIntededAfterTenMinutesOnHardAndCompactSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Hard andPorosity:#Compact.
	lunarRover:=LunarRover digOn: soilType.
	
	lunarRover minutesWorking: 10.
	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Close.
	self assert:(lunarRover rotation)equals:#CounterClockWise.
	self assert:(lunarRover speedInRPM)equals:150.
	self assert:(lunarRover timeRemainingOfWork )equals:10.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test05LunarRoverWorksAsIntededAfterFiveMinutesOnSoftAndPorousSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Soft andPorosity:#Porous.
	lunarRover:=LunarRover digOn: soilType.
	
	lunarRover minutesWorking: 5.
	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Close.
	self assert:(lunarRover rotation)equals:#ClockWise.
	self assert:(lunarRover speedInRPM)equals:100.
	self assert:(lunarRover timeRemainingOfWork )equals:5.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test06LunarRoverWorksAsIntededAfterFiveMinutesOnIntermediateSoil
	
	|lunarRover soilType|
	
	soilType := SoilType hardness: #Intermediate andPorosity:#Intermediate.
	lunarRover:=LunarRover digOn: soilType.
	
	lunarRover minutesWorking: 5.
	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Close.
	self assert:(lunarRover rotation)equals:#CounterClockWise.
	self assert:(lunarRover speedInRPM)equals:100.
	self assert:(lunarRover timeRemainingOfWork )equals:10.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test07LunarRoverCanNotCloseHandIfItIsStillExcavatingOnHardAndCompactSoil
	
	|lunarRover soilType rotation speed|
	
	soilType := SoilType hardness: #Hard andPorosity:#Compact.
	lunarRover:=LunarRover digOn: soilType.
	
	rotation := lunarRover rotation.
	speed := lunarRover speedInRPM.
	
	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:rotation.
	self assert:(lunarRover speedInRPM)equals:speed.
	self assert:(lunarRover timeRemainingOfWork )equals:10.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test08LunarRoverCanNotCloseHandIfItIsStillExcavatingOnSoftAndPorousSoil
	
	|lunarRover soilType rotation speed|
	
	soilType := SoilType hardness: #Soft andPorosity:#Porous.
	lunarRover:=LunarRover digOn: soilType.
	
	rotation := lunarRover rotation.
	speed := lunarRover speedInRPM.
	
	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:rotation.
	self assert:(lunarRover speedInRPM)equals:speed.
	self assert:(lunarRover timeRemainingOfWork )equals:5.! !

!LunarRoverTest methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
test09LunarRoverCanNotCloseHandIfItIsStillExcavatingOnIntermediateSoil
	
	|lunarRover soilType rotation speed|
	
	soilType := SoilType hardness: #Intermediate andPorosity:#Intermediate.
	lunarRover:=LunarRover digOn: soilType.
	
	rotation := lunarRover rotation.
	speed := lunarRover speedInRPM.

	lunarRover closeHand.
	
	self assert:(lunarRover handState)equals:#Open.
	self assert:(lunarRover rotation)equals:rotation.
	self assert:(lunarRover speedInRPM)equals:speed.
	self assert:(lunarRover timeRemainingOfWork )equals:5.! !


!classDefinition: #LunarRover category: #ToTheMoonRemake!
Object subclass: #LunarRover
	instanceVariableNames: 'rotation speed soilType timeRemainingToExcavate handState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:47:55'!
closeHand
	
	(timeRemainingToExcavate = 0)ifTrue: [
												rotation := soilType rotationWithSample .
												speed := soilType speedInRPMWithSample .
												timeRemainingToExcavate := soilType durationInMinutesWithSample .
												handState := #Close.].! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:45:31'!
handState

	^handState .! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:45:31'!
initializeForSoilType: aSoilType

	soilType := aSoilType .
	rotation := aSoilType rotationWithoutSample .
	speed := aSoilType speedInRPMWithoutSample .
	timeRemainingToExcavate := aSoilType durationInMinutesWithoutSample .
	handState  := #Open.! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:35:04'!
minutesWorking: anAmountOfMinutes

	^timeRemainingToExcavate := 0 max:( timeRemainingToExcavate - anAmountOfMinutes ) .! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:45:54'!
rotation

	^rotation .! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:46:00'!
speedInRPM

	^speed .! !

!LunarRover methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:46:09'!
timeRemainingOfWork

	^timeRemainingToExcavate .! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'LunarRover class' category: #ToTheMoonRemake!
LunarRover class
	instanceVariableNames: ''!

!LunarRover class methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:58:05'!
digOn: aSoilType

	^self new   initializeForSoilType: aSoilType .! !


!classDefinition: #SoilType category: #ToTheMoonRemake!
Object subclass: #SoilType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:33:45'!
durationInMinutesWithSample

	^self subclassResponsibility ! !

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:33:49'!
durationInMinutesWithoutSample

	^self subclassResponsibility ! !

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:34:03'!
rotationWithSample

	self subclassResponsibility .! !

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:34:05'!
rotationWithoutSample

	self subclassResponsibility .! !

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:34:24'!
speedInRPMWithSample

	self subclassResponsibility .! !

!SoilType methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:34:27'!
speedInRPMWithoutSample

	self subclassResponsibility .! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!classDefinition: 'SoilType class' category: #ToTheMoonRemake!
SoilType class
	instanceVariableNames: ''!

!SoilType class methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:31:26'!
hardness: hardnessType andPorosity:porosityType.

	((hardnessType = #Hard) & (porosityType = #Compact))ifTrue:[^HardAndCompactSoil new.].
	((hardnessType = #Soft) & (porosityType = #Porous))ifTrue:[^SoftAndPorousSoil new.].
	^IntermediateSoil new.! !


!classDefinition: #HardAndCompactSoil category: #ToTheMoonRemake!
SoilType subclass: #HardAndCompactSoil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:41:34'!
durationInMinutesWithSample

	^10.! !

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:41:41'!
durationInMinutesWithoutSample

	^10.! !

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:39:09'!
rotationWithSample

	^#CounterClockWise! !

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:39:20'!
rotationWithoutSample

	^#ClockWise! !

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:40:39'!
speedInRPMWithSample

	^150.! !

!HardAndCompactSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:40:50'!
speedInRPMWithoutSample

	^150.! !


!classDefinition: #IntermediateSoil category: #ToTheMoonRemake!
SoilType subclass: #IntermediateSoil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:43:41'!
durationInMinutesWithSample

	^10.! !

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:43:19'!
durationInMinutesWithoutSample

	^5.! !

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:43:04'!
rotationWithSample

	^#CounterClockWise! !

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:43:10'!
rotationWithoutSample

	^#ClockWise! !

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:44:08'!
speedInRPMWithSample

	^100.! !

!IntermediateSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:42:43'!
speedInRPMWithoutSample

	^150.! !


!classDefinition: #SoftAndPorousSoil category: #ToTheMoonRemake!
SoilType subclass: #SoftAndPorousSoil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToTheMoonRemake'!

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:44:42'!
durationInMinutesWithSample

	^5.! !

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:44:45'!
durationInMinutesWithoutSample

	^5.! !

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/29/2019 16:50:24'!
rotationWithSample

	^#ClockWise! !

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:44:57'!
rotationWithoutSample

	^#CounterClockWise! !

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:45:05'!
speedInRPMWithSample

	^100.! !

!SoftAndPorousSoil methodsFor: 'as yet unclassified' stamp: 'MEV 6/27/2019 19:45:08'!
speedInRPMWithoutSample

	^100.! !
